require 'tmpdir'

module Csv2qti
  class Course
    attr_reader :title, :file_path, :primary_outcomes

    def initialize(title, file_path)
      @title = title
      @file_path = file_path
      @primary_outcomes = []
    end

    def add_primary_outcome(row)
      @primary_outcomes << Outcome.new(row)
      @primary_outcomes.last
    end

    def generate_cc(filename=nil)
      filename ||= @title
      course = CanvasCc::CanvasCC::Models::Course.new
      course.title = @title
      course.identifier = rand(1000).to_s

      @primary_outcomes.each do |po|
        course.assessments << po.generate_assessment
      end

      dir = Dir.mktmpdir
      file = CanvasCc::CanvasCC::CartridgeCreator.new(course).create(dir)

      FileUtils.mv(file, "./#{filename.downcase.gsub(' ', '_')}.zip")
    end

    def to_s
      @primary_outcomes.inject("#{title}\nOutcomes:") { |s, o| s + "\n" + o.to_s }
    end
  end
end