module Csv2qti
  class MultipleChoice < Question

    attr_reader :distractors, :answer

    def initialize(row)
      super(row)
      @distractors = process_distractors(row)
      @answer = row[CORRECT]
    end

    def type
      'MULTIPLE_CHOICE'
    end

    def generate_cc_question
      question = CanvasCc::CanvasCC::Models::Question.create('multiple_choice_question')
      question.material = stem
      question.identifier = rand(10000)
      question.answers = @distractors.map {|d| make_answer(d)} << make_answer(@answer, true)

      question
    end

    def to_qti
      Nokogiri::XML::Builder.new(encoding: 'UTF-8') do |node|
       CanvasCc::CanvasCC::MultipleChoiceQuestionWriter.write_question(node, generate_cc_question)
      end.doc.to_xml
    end

    private

    def make_answer(text, correct=false)
      answer = CanvasCc::CanvasCC::Models::Answer.new
      answer.id = rand(10000)
      answer.fraction = correct ? 1.0 : 0.0
      answer.answer_text = text
      answer
    end
  end
end